/**************************************************************************
**       Title:
**    $RCSfile: MinimalStData.hh,v $
**   $Revision: 1.1 $$Name:  $
**       $Date: 2004/08/26 08:36:59 $
**   Copyright: GPL $Author: ronneber $
** Description:
**
**     dummy class that contains the minimal interface for StData-classes 
**
**-------------------------------------------------------------------------
**
**  $Log: MinimalStData.hh,v $
**  Revision 1.1  2004/08/26 08:36:59  ronneber
**  initital import
**
**
**
**************************************************************************/

#ifndef MINIMALSTDATA_HH
#define MINIMALSTDATA_HH

#include <string>

#include "RequireHelpers.hh"
#include "MinimalFeatureVector.hh"
#include "RequireForwardIter.hh"

namespace svt_check
{
  
  class MinimalStData
  {
  public:
    
    void setExceptionFlag( bool f)   {}
    
    bool exceptionFlag() const  { return true;}

    bool valueExists(const std::string&) const { return true;}
    
    
    void setValue( const std::string&, const bool& ) {}
    void setValue( const std::string&, const int& ) {}
    void setValue( const std::string&, const unsigned int& ) {}
    void setValue( const std::string&, const float& ) {}
    void setValue( const std::string&, const double& ) {}
    void setValue( const std::string&, const std::string& ) {}
    
    template<typename ForwardIter>
    void setArray( const std::string&, const ForwardIter& arrBegin,
                   unsigned int)
          {
            if(false)
            {
              CHECK_MEMBER_TEMPLATE( RequireForwardIter<ForwardIter> );
              checkSetArray_ValueTypes( *arrBegin);
            }
          }
    
  private:
    void checkSetArray_ValueTypes( double) {}
    void checkSetArray_ValueTypes( unsigned int) {}
    
  public:
    template<typename ForwardIter>
    void setFVArray( const std::string& key, const ForwardIter& arrBegin,
                     unsigned int size)
          {
            if( false)
            {
              CHECK_MEMBER_TEMPLATE( RequireForwardIter<ForwardIter> );
              checkSetFVArray_ValueTypes( *arrBegin);
            }
            
          }
    
  private:
    void checkSetFVArray_ValueTypes( MinimalFeatureVector* dummy) {}
    
  public:
    void getValue( const std::string& key, const bool& value) {}
    void getValue( const std::string& key, const int& value) {}
    void getValue( const std::string& key, const unsigned int& value) {}
    void getValue( const std::string& key, const float& value) {}
    void getValue( const std::string& key, const double& value) {}
    void getValue( const std::string& key, const std::string& value) {}
    
    unsigned int getArraySize( std::string key) 
          { return 0;}  
    
    unsigned int getFVArraySize( std::string key) 
          { return 0;}  
    
    template<typename ForwardIter> 
    void getArray( const std::string& key, const ForwardIter& arrBegin, 
                   int containerSize=-1)
          {
            if(false)
            {
              CHECK_MEMBER_TEMPLATE( RequireForwardIter<ForwardIter> );
              checkSetArray_ValueTypes( *arrBegin);
            }
          }
    
    template<typename ForwardIter> 
    void getFVArray( const std::string& key, const ForwardIter& arrBegin, 
                     int containerSize=-1)
          {
            if(false)
            {
              CHECK_MEMBER_TEMPLATE( RequireForwardIter<ForwardIter> );
              checkSetFVArray_ValueTypes( *arrBegin);
            }
            
          }
    
  };
}



#endif
